! utf-8
! 文字コードはutf-8
! 自由形式のfortranで書いています。
! g77でコンパイルする場合は、
!g77 -ffree-form -o smv smv.f
! のようにコンパイルしてください。
! gfortran でコンパイルする場合は文字コードをutf-8にしてください。
program ble6ccx
implicit real*8 (a-h, o-z)
dimension x(3000000),y(3000000),z(3000000),&
&         mesh(1000000,6),narabi(10000,10000)
character mozi*20,mozi0*20
read*, mozi0 !1行目の文字を読み込む
read*, nset !節点数の読み込み
do i=0,nset-1
 read*, x(i),y(i),z(i) !各節点の座標値の読み込み
end do
!
open(7,file='yousosuu.txt') !yousosuu.fで数えた要素数ファイル
read(7,*) nyou !要素数の読み込み
do i=1,nyou
!各要素の頂点数?、各頂点の節点番号、カラーコード?の読み込み
read*,kazu,mesh(i,1),mesh(i,2),mesh(i,3),mozi
end do
!
do i=0,nset
do j=0,nset
!隣り合う節点i,jの中間の節点番号の初期値をすべて-1にしておく
narabi(i,j)=-1
end do
end do
!
!
!中間点に新たに節点番号をふっていくのだが、
!頂点だけの節点数がnset個で、blenderの節点番号は0から始まるから、
!まだ使ってない一番若い節点番号はnset-1番
iset=nset-1
do i=1,nyou !1要素目からnyou要素まで順番に中間節点をふる
 !頂点1-2間に中間節点番号がまだふられていなければ、
 if(narabi(mesh(i,1),mesh(i,2))==-1) then
  iset=iset+1 !節点番号を1増やして
  narabi(mesh(i,1),mesh(i,2))=iset !頂点1-2間と
  narabi(mesh(i,2),mesh(i,1))=iset !頂点2-1間とに節点番号isetをふり
  mesh(i,4)=iset !その節点番号をi要素目の頂点5に覚えさせる
  !頂点5のxyz座標を頂点1-2間の中点として与える
  x(iset)=(x(mesh(i,1))+x(mesh(i,2)))/2.d0
  y(iset)=(y(mesh(i,1))+y(mesh(i,2)))/2.d0
  z(iset)=(z(mesh(i,1))+z(mesh(i,2)))/2.d0
 else
  !頂点1-2間にすでに節点番号がふられていれば、
  mesh(i,4)=narabi(mesh(i,1),mesh(i,2)) !それを頂点5の節点番号にする
 end if
!       頂点2-3,3-1間も以下同様に
 if(narabi(mesh(i,2),mesh(i,3))==-1) then
  iset=iset+1
  narabi(mesh(i,2),mesh(i,3))=iset
  narabi(mesh(i,3),mesh(i,2))=iset
  mesh(i,5)=iset
  x(iset)=(x(mesh(i,2))+x(mesh(i,3)))/2.d0
  y(iset)=(y(mesh(i,2))+y(mesh(i,3)))/2.d0
  z(iset)=(z(mesh(i,2))+z(mesh(i,3)))/2.d0
 else
  mesh(i,5)=narabi(mesh(i,2),mesh(i,3))
 end if
!
 if(narabi(mesh(i,3),mesh(i,1))==-1) then
  iset=iset+1
  narabi(mesh(i,3),mesh(i,1))=iset
  narabi(mesh(i,1),mesh(i,3))=iset
  mesh(i,6)=iset
  x(iset)=(x(mesh(i,3))+x(mesh(i,1)))/2.d0
  y(iset)=(y(mesh(i,3))+y(mesh(i,1)))/2.d0
  z(iset)=(z(mesh(i,3))+z(mesh(i,1)))/2.d0
 else
  mesh(i,6)=narabi(mesh(i,3),mesh(i,1))
 end if
 nset=iset
end do
!
!
!!!!!!!!!!!!!!!!!!!!!!
!open(9,file='ble6ccx.inp')
print'("** blenderのobjファイルをccxのS6要素inp化")'
print'("**")'
print'("*NODE, NSET=Nall")'
do i=0,nset
   print'(i6,a,1pe15.3,a,1pe15.3,a,1pe15.3)'&
   !print* &
   &,i+1,',',x(i),',',y(i),',',z(i)
end do
print'("*ELEMENT, TYPE=S6, ELSET=Eall")'
do i=1,nyou
   print'(i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6)',&
   i,',',mesh(i,1)+1,',',mesh(i,2)+1,',',mesh(i,3)+1,',',mesh(i,4)+1&
&   ,',',mesh(i,5)+1,',',mesh(i,6)+1
end do
print'("*NSET,NSET=FIX")'
print'("** ここに拘束したい節点番号とコンマを1行ずつ並べる")'
print'("** 例えば拘束節点が1と2だったら")'
print'(i6,a)',1,','
print'(i6,a)',2,','
print'("** みたいに")'
print'("*BOUNDARY")'
print'("** 以下のFIX,に続けて拘束変位1=x,2=y,3=zをコンマ区切りで")'
print'("FIX,1,3")'
print'("*MATERIAL,NAME=EL")'
print'("*ELASTIC")'
e=210000. ! ヤング率(MPa)
poi=0.3   !  ポアソン比
print*, e,',',poi
t=10.d-3 !板の厚さ(m)
print'("*SHELL SECTION,ELSET=Eall,MATERIAL=EL,OFFSET=0.")'
print*,t
!温度設定
!print'("*INITIAL CONDITIONS,TYPE=TEMPERATURE")'
!print'("Nall,273.")'
!節点ごとに厚さを変えたい時
!print'("*NSET,NSET=ATUSA")'
!do i=1,nset
!print'(i6,a)',i,','
!end do
!print'("*NODAL THICKNESS")'
!print*,'ATUSA,',t
print'("*NSET,NSET=SAIKA")'
print'("** ここに載荷したい節点番号とコンマを1行ずつ並べる")'
print'("** 例えば載荷節点が3と4だったら")'
print'(i6,a)',3,','
print'(i6,a)',4,','
print'("** みたいに")'
print'("*STEP")'
print'("*STATIC,SOLVER=SPOOLES")'
print'("*CLOAD")'
p=1.d-0 !載荷荷重(MN)
nsaika=2 !載荷節点数
print'("** 以下のSAIKAに続けて載荷方向、載荷荷重を書く")'
print'("** 例えば載荷方向が3=zで、載荷荷重がp/nsaikaなら")'
print*,'SAIKA,3,',p/nsaika
print'("*NODE PRINT,NSET=Nall")'
print'("U")'
print'("*EL PRINT,ELSET=Eall")'
print'("S")'
print'("*NODE FILE")'
print'("U")'
print'("*EL FILE,POSITION=AVERAGED AT NODES")'
print'("S")'
print'("*END STEP")'
!
!
!!!!!!!!!!!!!!!!!!!!!!
!
open(8,file='ble6ccx.obj')
write(8,'("3DG1")')
write(8,*) nset+1
do i=0,nset
write(8,*) x(i),y(i),z(i)
end do
!
do i=1,nyou
   write(8,*) 6,mesh(i,1),mesh(i,2),mesh(i,3),mesh(i,4)&
&              ,mesh(i,5),mesh(i,6),' ','0xcccccc'
end do
!
end

